<?php
/*
= Header for the LuxCal calendar pages =

 Copyright 2009-2018 LuxSoft - www.LuxSoft.eu

This file is part of the LuxCal Web Calendar.

The LuxCal Web Calendar is free software: you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software Foundation, 
either version 3 of the License, or (at your option) any later version.

The LuxCal Web Calendar is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the LuxCal 
Web Calendar. If not, see: http://www.gnu.org/licenses/.
*/

//sanity check
if (empty($lcV)) { exit('not permitted ('.substr(basename(__FILE__),0,-4).')'); } //launch via script only

//functions
function headerTop() {
echo "<style>
.content {margin-top:-48px;}
</style>";
}

function headerRss() {
global $set, $usr, $cF;

	if ($usr['privs'] > 0 and $set['rssFeed']) {
		echo '<link rel="alternate" type="application/rss+xml" title="LuxCal RSS Feed" href="http://'.$_SERVER['SERVER_NAME'].rtrim(dirname($_SERVER["PHP_SELF"]),'/').'/rssfeed.php'.$cF.'">'."\n";
	}
}

function admMenu() {
	global $xx, $opt, $usr;

	if ($usr['privs'] >= 4) { //manager or admin rights
		$optNames = array(90 => 'hdr_settings','hdr_categories','hdr_users','hdr_groups','hdr_database','hdr_import_ics','hdr_export_ics','hdr_import_csv','hdr_styling');
		echo "<select title=\"{$xx['hdr_select_admin_functions']}\" name='views' onchange='jumpPage(this,value)'>\n<option hidden value='-1'>{$xx['hdr_admin']}&nbsp;</option>\n";
		$selected = array_fill(90,11,'');
		$selected[$opt['cP']] = ' selected';
		if ($usr['privs'] == 4) { //manager
			for ($i=91; $i<=93; $i++) {
				echo "<option value='{$i}'{$selected[$i]}>{$xx[$optNames[$i]]}</option>\n";
			}
		} else { //admin
			for ($i=90; $i<=97; $i++) {
				echo "<option value='{$i}'{$selected[$i]}>{$xx[$optNames[$i]]}</option>\n";
			}
			echo "<option value='99'{$selected[99]}>{$xx['hdr_styling']}</option>\n";
		}
		echo "</select> \n";
	}
}

function headerHdr() {
	global $set, $usr, $today;

	echo "<h1>
<span class='floatL'>{$set['calendarTitle']}</span><span class='floatR'>{$usr['name']}</span><span class='noPrint point' onclick=\"index({cD:'{$today}'})\">".makeD($today,5)."</span>
</h1>\n";
}

function calButton () {
	global $xx;

	echo "<button type='button' title=\"{$xx['hdr_back_to_cal']}\" onclick=\"index({cP:0})\">{$xx['hdr_calendar']}</button>\n";
}

function prtButton () {
	global $xx;

	echo "<button type='button' title=\"{$xx['hdr_print_page']}\" onclick='printNice();'>{$xx['hdr_button_print']}</button>\n";
}

function toaButton () {
	global $xx, $set;

	if ($set['navToapList']) {
		echo "<button type='button' title=\"{$xx['hdr_toap_list']}\" onclick=\"show('toapBar')\">".($set['navButText'] ? $xx['hdr_button_toap'] : '&nbsp;&#8804;&nbsp;')."</button>\n";
	}
}

function tdlButton () {
	global $xx, $set;

	if ($set['navTodoList']) {
		echo "<button type='button' title=\"{$xx['hdr_todo_list']}\" onclick=\"show('todoBar')\">".($set['navButText'] ? $xx['hdr_button_todo'] : '&nbsp;&#8801;&nbsp;')."</button>\n";
	}
}

function upcButton () {
	global $xx, $set;

	if ($set['navUpcoList']) {
		echo "<button type='button' title=\"{$xx['hdr_upco_list']}\" onclick=\"show('upcoBar')\">".($set['navButText'] ? $xx['hdr_button_upco'] : '&nbsp;&#8804;&nbsp;')."</button>\n";
	}
}

function srcButton() {
	global $xx, $set;

	echo "<button type='button' title=\"{$xx['hdr_search']}\" onclick=\"index({cP:21})\">".($set['navButText'] ? $xx['hdr_button_search'] : '&nbsp;&#916;&nbsp;')."</button>\n";
}

function addButton() {
	global $xx, $opt, $set, $usr;

	if ($usr['privs'] > 1) { //post rights
		$cid = (count($opt['cC']) == 1 and $opt['cC'][0] != 0) ? $opt['cC'][0] : 0;
		echo "<button type='button' title=\"{$xx['hdr_add_event']}\" onclick=\"newE(0,{$cid});\">".($set['navButText'] ? $xx['hdr_button_add'] : '&nbsp;+&nbsp;')."</button>\n";
	}
	unset($cid);
}

function hlpButton($cPage) {
	global $xx, $set;

	echo "<button type='button' title=\"{$xx['hdr_user_guide']}\" onclick=\"help({$cPage});\">".($set['navButText'] ? $xx['hdr_button_help'] : '&nbsp;?&nbsp;')."</button>\n";
}

function logButton() {
	global $xx, $usr;

	if ($usr['ID'] == 1) { //public user
		echo "<button type='button' onclick=\"index({cP:20});\">{$xx['hdr_button_log_in']}</button>\n";
	} else { //known user
		echo "<button type='button' onclick=\"index({cP:0,loff:1});\">{$xx['hdr_button_log_out']}</button>\n";
	}
}

function urlButton() {
	global $xx, $set;

	if ($set['backLinkUrl']) {
		echo "<button id='urlButton' type='button' title=\"{$xx['hdr_button_back']}\" onclick=\"window.location.href='{$set['backLinkUrl']}';\">{$xx['back']}</button>\n";
	}
}

function optButton() {
	global $options, $xx;

	if ($options) { //no menus
		echo "<button type='button' id='optButton' title=\"{$xx['hdr_options_panel']}\" onclick=\"toggleLabel('optButton','{$xx['options']}','{$xx['done']}'); show('optPanel','optMenu')\">{$xx['options']}</button>\n";
	}
}

function viewButtons() {
	global $xx, $set, $usr;

	$viewButtons = $usr['ID'] == 1 ? $set['viewButsPub'] : $set['viewButsLog']; //view buttons to display
	if ($viewButtons) {
		foreach (explode(',',$viewButtons) as $viewNr) {
			$label = $xx["hdr_view_{$viewNr}"];
			echo "<button type='button' title=\"{$xx['hdr_go_to_view']}\" onclick=\"index({cP:{$viewNr}})\">{$label}</button>\n";
		}
	}
	unset($viewButtons,$label);
}

function dateForm() {
	global $xx, $opt, $lcI;

	echo "<form class='inline' id='gotoD' name='gotoD' action='index.php' method='post'>
<input type='hidden' name='lcI' value='{$lcI}'>
<input size='10' type='text' name='nD' id='nD' value='".IDtoDD($opt['cD'])."'>
<button type='button' title=\"{$xx['hdr_select_date']}\" onclick=\"dPicker(0,'gotoD','nD');return false;\">&larr;</button>
</form>\n";
}

function optPanel() { //make options panel
	global $options, $xx, $set, $calID, $usr, $opt, $avViews, $dbSel, $lcI;

	if (!$options) { return; } //no menus
	
	echo "<div id='optPanel'>
<h3 class='floatC point' onclick=\"show('optPanel','optMenu')\">{$xx['hdr_options_submit']}</h3>
<form name='optMenu' action='index.php' method='post'>\n
<input type='hidden' name='lcI' value='{$lcI}'>";
	if ($dbSel and $usr['privs'] == 9) { //get calendar database IDs
		$calIDs = getCIDs(); //get all calender IDs
		if (count($calIDs) > 1) { //more than 1 calendar
			echo "<div class='option'>\n<div class='optHead'>{$xx['hdr_calendar']}</div>\n<div class='optList'>\n";
			foreach ($calIDs as $cal) {
				$checked = ($calID == $cal) ? " checked" : '';
				echo "<input type='checkbox' id='{$cal}' name='cal' value='{$cal}' onclick=\"check1('cal',this);\"{$checked}><label for='{$cal}'>".$cal."</label><br>\n";
			}
			echo "</div>\n</div>\n";
		}
	}
	if ($set['viewMenu']) {
		$checkedA = array_fill(1,10,'');
		$checkedA[$opt['cP']] = " checked";
		echo "<div class='option'>\n<div class='optHead'>{$xx['hdr_view']}</div>\n<div class='optList'>";
		for ($i=1; $i<11; $i++) {
			$v = strval($i);
			if (strpos($avViews,$v) !== false) {
				$vLabel = $xx["hdr_view_{$v}"];
				echo "<input type='checkbox' id='cP{$v}' name='cP' value='{$v}' onclick=\"check1('cP',this);\"{$checkedA[$i]}><label for='cP{$v}'>{$vLabel}</label><br>\n";
			}
		}
		echo "</div>\n</div>\n";
	}
	if ($set['groupMenu']) {
		echo "<div class='option'>\n<div class='optHead'>{$xx['hdr_groups']}</div>\n<div class='optList'>\n";
		$stH = dbQuery("SELECT `ID`,`name`,`color` FROM `groups` WHERE `status` >= 0 ORDER BY `name`");
		$checked = in_array(0, $opt['cG']) ? " checked" : '';
		echo "<input type='checkbox' id='cG0' name='cG[]' value='0' onclick=\"checkZ('cG',this);\"{$checked}><label for='cG0'>{$xx['hdr_all_groups']}</label><br>\n";
		while (list($xgID,$gName,$color) = $stH->fetch(PDO::FETCH_NUM)) {
			$checked = in_array($xgID, $opt['cG']) ? " checked" : '';
			$groupColor = ($color) ? " style='background-color:{$color};'" : '';
			echo "<input type='checkbox' id='cG{$xgID}' name='cG[]' value='{$xgID}' onclick=\"checkN('cG',this);\"{$checked}><label for='cG{$xgID}'{$groupColor}>{$gName}</label><br>\n";
		}
		echo "</div>\n</div>\n";
	}
	if ($set['userMenu'] and $usr['ID'] > 1) {
		echo "<div class='option'>\n<div class='optHead'>{$xx['hdr_users']}</div>\n<div class='optList'>\n";
		$stH = dbQuery("SELECT u.`ID`,u.`name`,g.`color` FROM `users` AS u INNER JOIN `groups` AS g ON g.`ID` = u.`groupID` WHERE u.`status` >= 0 ORDER BY u.`name`");
		$checked = in_array(0, $opt['cU']) ? " checked" : '';
		echo "<input type='checkbox' id='cU0' name='cU[]' value='0' onclick=\"checkZ('cU',this);\"{$checked}><label for='cU0'>{$xx['hdr_all_users']}</label><br>\n";
		while (list($xuID,$uName,$color) = $stH->fetch(PDO::FETCH_NUM)) {
			$checked = in_array($xuID, $opt['cU']) ? " checked" : '';
			$userColor = ($color) ? " style='background-color:{$color};'" : '';
			echo "<input type='checkbox' id='cU{$xuID}' name='cU[]' value='{$xuID}' onclick=\"checkN('cU',this);\"{$checked}><label for='cU{$xuID}'{$userColor}>{$uName}</label><br>\n";
		}
		echo "</div>\n</div>\n";
	}
	if ($set['catMenu']) {
		echo "<div class='option'>\n<div class='optHead'>{$xx['hdr_categories']}</div>\n<div class='optList'>\n";
		$where = ' WHERE `status` >= 0'.($usr['vCats'] != '0' ? " AND `ID` IN ({$usr['vCats']})" : '');
		$stH = dbQuery("SELECT `name`,`sequence`,`color`,`bgColor` FROM `categories`".$where." ORDER BY `sequence`");
		$checked = in_array(0, $opt['cC']) ? " checked" : '';
		echo "<input type='checkbox' id='cC0' name='cC[]' value='0' onclick=\"checkZ('cC',this);\"{$checked}><label for='cC0'>{$xx['hdr_all_cats']}</label><br>\n";
		while (list($cName,$xC,$color,$bgColor) = $stH->fetch(PDO::FETCH_NUM)) {
			$checked = in_array($xC, $opt['cC']) ? " checked" : '';
			$catColor = ($color ? "color:{$color};" : '').($bgColor ? "background-color:{$bgColor};" : '');
			echo "<input type='checkbox' id='cC{$xC}' name='cC[]' value='{$xC}' onclick=\"checkN('cC',this);\"{$checked}><label for='cC{$xC}'".($catColor ? " style=\"".$catColor."\"" : "").">{$cName}</label><br>\n";
		}
		echo "</div>\n</div>\n";
	}
	if ($set['langMenu']) {
		echo "<div class='option'>\n<div class='optHead'>{$xx['hdr_lang']}</div>\n<div class='optList'>\n";
		$files = scandir("lang/");
		foreach ($files as $file) {
			if (substr($file, 0, 3) == "ui-") {
				$lang = strtolower(substr($file,3,-4));
				$checked = ($opt['cL'] == $lang) ? " checked" : '';
				echo "<input type='checkbox' id='{$lang}' name='cL' value='{$lang}' onclick=\"check1('cL',this);\"{$checked}><label for='{$lang}'>".ucfirst($lang)."</label><br>\n";
			}
		}
		echo "</div>\n</div>\n";
	}
	echo "</form>\n</div>\n";
}

function toapList() { //make list with events to be approved
	global $xx, $set, $opt, $usr, $evtList;
	
	if ($set['navToapList']) {
		echo "<div id='toapBar'>
<div class='topBar move' onmousedown=\"dragMe('toapBar',event)\">{$xx['hdr_toap_list']}<span class='floatR select' onclick=\"show('toapBar')\">&nbsp;&#10060;&nbsp;</span></div>\n";
		$curD = $opt['cD'];
		$curT = mktime(12,0,0,substr($curD,5,2),substr($curD,8,2),substr($curD,0,4)); //current Unix time
		$startD = date("Y-m-d", $curT - (7 * 86400)); //current date - 1 week
		$endD = date("Y-m-d", $curT + (($set['lookaheadDays']-1) * 86400)); //current date + look ahead nr of days
		$filter = '(c.`approve` = 1 AND e.`approved` = 0)'; //events in cat to be approved but not yet approved
		retrieve($startD,$endD,'guc',$filter);

		echo '<h5 class="floatC">'.IDtoDD($startD).' - '.IDtoDD($endD)."</h5>\n";
		//display list
		echo "<div class='barBody'>\n";
		if ($evtList) {
			$evtDone = array();
			$lastDate = '';
			foreach($evtList as $date => &$events) {
				foreach ($events as $evt) {
					if (!$evt['mde'] or !in_array($evt['eid'],$evtDone)) { //!mde or mde not processed
						$evtDone[] = $evt['eid'];
						$evtDate = $evt['mde'] ? makeD($evt['sda'],5)." - ".makeD($evt['eda'],5) : makeD($date,5);
						$evtTime = $evt['ald'] ? $xx['vws_all_day'] : ITtoDT($evt['sti']).($evt['eti'] ? ' - '.ITtoDT($evt['eti']) : '');
						$onClick = " class='point' onclick=\"editE({$evt['eid']},'{$date}');\"";
						if ($set['eventColor']) {
							$eStyle = ($evt['cco'] ? "color:{$evt['cco']};" : '').($evt['cbg'] ? "background-color:{$evt['cbg']};" : '');
						} else {
							$eStyle = ($evt['uco'] ? "background-color:{$evt['uco']};" : '');
						}
						$eStyle = $eStyle ? " style='{$eStyle}'" : '';
						echo $lastDate != $evtDate ? "<h5>{$evtDate}</h5>\n" : '';
						echo "<p>{$evtTime}</p><p{$onClick}{$eStyle}>&nbsp;&nbsp;{$evt['tit']}</p><br>\n";
						$lastDate = $evtDate;
					}
				}
			}
		} else {
			echo $xx['none']."\n";
		}
		echo "</div>\n</div>\n";
	}
}

function todoList() { //make list with todo events
	global $xx, $set, $opt, $usr, $evtList;
	
	if ($set['navTodoList']) {
		echo "<div id='todoBar'>
<div class='topBar move' onmousedown=\"dragMe('todoBar',event)\">{$xx['hdr_todo_list']}<span class='floatR select' onclick=\"show('todoBar')\">&nbsp;&#10060;&nbsp;</span></div>\n";
		$curD = $opt['cD'];
		$curT = mktime(12,0,0,substr($curD,5,2),substr($curD,8,2),substr($curD,0,4)); //current Unix time
		$startD = date("Y-m-d", $curT - (30 * 86400)); //current date - 1 month
		$endD = date("Y-m-d", $curT + (($set['lookaheadDays']-1) * 86400)); //current date + look ahead nr of days
		$filter = '(c.`checkBx` = 1)'; //events in cat with a check mark
		retrieve($startD,$endD,'guc',$filter);

		echo '<h5 class="floatC">'.IDtoDD($startD).' - '.IDtoDD($endD)."</h5>\n";
		//display list
		echo "<div class='barBody'>\n";
		if ($evtList) {
			foreach($evtList as $date => &$events) {
				$dShown = 0;
				foreach ($events as $evt) {
					if (strpos($evt['chd'],$date)) { continue; } //flush completed events
					if (!$dShown) {
						echo "<h5>".makeD($date,5)."</h5>\n";
						$dShown = 1;
					}
					$evtTime = $evt['ald'] ? $xx['vws_all_day'] : ITtoDT($evt['sti']).($evt['eti'] ? ' - '.ITtoDT($evt['eti']) : '');
					$mayView = ($set['details4All'] == 1 or ($set['details4All'] == 2 and $usr['ID'] > 1) or $evt['mayE']);
					$click = ($evt['mayE'] ? 'editE' : 'showE')."({$evt['eid']},'{$date}')";
					$onClick = $mayView ? " class='point' onclick=\"{$click};\"" : " class='arrow'";
					if ($set['eventColor']) {
						$eStyle = ($evt['cco'] ? "color:{$evt['cco']};" : '').($evt['cbg'] ? "background-color:{$evt['cbg']};" : '');
					} else {
						$eStyle = ($evt['uco'] ? "background-color:{$evt['uco']};" : '');
					}
					$eStyle = $eStyle ? " style='{$eStyle}'" : '';
					$chBox = '';
					if ($evt['cbx']) {
						$mayCheck = ($usr['privs'] > 3 or ($usr['privs'] > 1 and $evt['uid'] == $usr['ID'])) ? true : false;
						$chBox .= strpos($evt['chd'], $date) ? $evt['cmk'] : '&#x2610;';
						$cBoxAtt = $mayCheck ? "class='chkBox floatL point' onclick=\"checkE(this,{$evt['eid']},'{$date}');\"" : "class='chkBox floatL arrow'";
						$chBox = "<span title='{$evt['clb']}' {$cBoxAtt}>{$chBox}</span>";
					}
					echo "<p>{$evtTime}</p>\n{$chBox}<p{$onClick}{$eStyle}>&nbsp;&nbsp;{$evt['tit']}</p><br>\n";
				}
			}
		} else {
			echo $xx['none']."\n";
		}
		echo "</div>\n</div>\n";
	}
}

function upcoList() { //make list with upcoming events
	global $xx, $set, $opt, $usr, $evtList;

	if ($set['navUpcoList']) {
		echo "<div id='upcoBar'>
<div class='topBar move' onmousedown=\"dragMe('upcoBar',event)\">{$xx['hdr_upco_list']}<span class='floatR select' onclick=\"show('upcoBar')\">&nbsp;&#10060;&nbsp;</span></div>\n";
		$startD = $opt['cD'];
		$eTime = mktime(12,0,0,substr($startD,5,2),substr($startD,8,2),substr($startD,0,4)) + (($set['lookaheadDays']-1) * 86400); //Unix time of end date
		$endD = date("Y-m-d", $eTime);
		retrieve($startD,$endD,'guc');

		echo '<h5 class="floatC">'.IDtoDD($startD).' - '.IDtoDD($endD)."</h5>\n";
		//display events
		echo "<div class='barBody'>\n";
		if ($evtList) {
			$evtDone = array();
			$lastDate = '';
			foreach($evtList as $date => &$events) {
				foreach ($events as $evt) {
					if (!$evt['mde'] or !in_array($evt['eid'],$evtDone)) { //!mde or mde not processed
						$evtDone[] = $evt['eid'];
						$evtDate = $evt['mde'] ? makeD($evt['sda'],5)." - ".makeD($evt['eda'],5) : makeD($date,5);
						$evtTime = $evt['ald'] ? $xx['vws_all_day'] : ITtoDT($evt['sti']).($evt['eti'] ? ' - '.ITtoDT($evt['eti']) : '');
						$mayView = ($set['details4All'] == 1 or ($set['details4All'] == 2 and $usr['ID'] > 1) or $evt['mayE']);
						$click = ($evt['mayE'] ? 'editE' : 'showE')."({$evt['eid']},'{$date}')";
						$onClick = $mayView ? " class='point' onclick=\"{$click};\"" : " class='arrow'";
						if ($set['eventColor']) {
							$eStyle = ($evt['cco'] ? "color:{$evt['cco']};" : '').($evt['cbg'] ? "background-color:{$evt['cbg']};" : '');
						} else {
							$eStyle = ($evt['uco'] ? "background-color:{$evt['uco']};" : '');
						}
						$eStyle = $eStyle ? " style='{$eStyle}'" : '';
						echo $lastDate != $evtDate ? "<h5>{$evtDate}</h5>\n" : '';
						echo "<p>{$evtTime}</p><p{$onClick}{$eStyle}>&nbsp;&nbsp;{$evt['tit']}</p><br>\n";
						$lastDate = $evtDate;
					}
				}
			}
		} else {
			echo $xx['none']."\n";
		}
		echo "</div>\n</div>\n";
	}
}

if (preg_match('/(iPhone|iPad|iPod)/i',$_SERVER['HTTP_USER_AGENT'])) { //iOS - mobile safari bug fix
	echo '<meta name="viewport" content="width=device-width, initial-scale=1">
';
}
//start of HTML header
$cssX = isset($_SESSION['theme']) ? '?pv='.time() : ''; //?pv: force reload of styles
$version = LCV;
$cid = (count($opt['cC']) == 1 and $opt['cC'][0] != 0) ? $opt['cC'][0] : 0;
$options = ($dbSel and $usr['privs'] == 9) or $set['viewMenu'] or $set['groupMenu'] or $set['userMenu'] or $set['catMenu'] or $set['langMenu']; //menus
echo "<!DOCTYPE html>
<html lang=\"".ISOCODE."\">\n";
echo <<<TXT
<head>
<meta charset="utf-8">
<title>{$set['calendarTitle']}</title>
<meta name="description" content="LuxCal web calendar - a LuxSoft product">
<meta name="application-name" content="LuxCal V{$version}">
<meta name="author" content="Roel Buining">
<meta name="robots" content="nofollow">
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="canonical" href="{$set['calendarUrl']}">
<link rel="icon" href="lcal.png" type="image/png">
<link rel="stylesheet" href="css/css.php{$cssX}" type="text/css">
<script>
var cid = {$cid}, mode = "{$mode}";
var tFormat = "{$set['timeFormat']}", dFormat = "{$set['dateFormat']}", wStart = {$set['weekStart']}, dwStartH = {$set['dwStartHour']}, dwEndH = {$set['dwEndHour']}, dwTimeSlot = {$set['dwTimeSlot']};
var dpToday = "{$xx['hdr_today']}", dpClear = "{$xx['hdr_clear']}", smlConfirm = "{$xx['vws_send_mail_to']}";
TXT;
echo "
var dpMonths = ['",implode("','",$months),"'];
var dpWkdays = ['",implode("','",$wkDays_m),"'];
</script>
<script src='common/toolbox.js'></script>\n";
unset($version);

switch ($hdrType) { //header types - 0: no, f: full, a: admin, l: login, m: mobile, s: styling, e: event, h: help
	case '0': //no header (hdr=0)
		headerTop();
		echo <<<TXT
</head>\n
<body>
<div class='content'>\n
TXT;
		if ($pageTitle) echo "<br><h2 class='pageTitle'>{$pageTitle}</h2>\n";
		break;
	case 'f': //normal pages
		headerRss();
		echo <<<TXT
<script async src="common/dtpicker.js"></script>
<script>window.onpageshow = function() {if((window.location != window.parent.location)) showX('urlButton',false);}</script>
</head>\n
<body onload="scrollY({$opt['cP']},'goto');" onunload="scrollY({$opt['cP']},'save');">\n
TXT;
		headerHdr();
		if ($usr['privs'] > 0) { //view rights
			echo "<div class='navBar noPrint'>\n";
			echo "<div class='floatR'>\n";
			prtButton();
			admMenu();
			if ($usr['privs'] >= 4) { toaButton(); } //manager+
			tdlButton();
			upcButton();
			srcButton();
			addButton();
			hlpButton($opt['cP']);
			logButton();
			echo "</div>\n";
			echo "<div class='floatL'>\n";
			urlButton();
			optButton();
			viewButtons();
			dateForm();
			echo "</div>\n";
			echo "<div ".($options ? "class='point noPrint' onclick=\"toggleLabel('optButton','{$xx['options']}','{$xx['done']}'); show('optPanel','optMenu')\"" : '').">&nbsp;</div>\n";
			echo "</div>\n";
			optPanel();
			if ($usr['privs'] >= 4) { toapList(); } //manager+ make side bar with events to be approved
			todoList(); //make side bar with todo list
			upcoList(); //make side bar with upcoming events
		} else { //display dummy navbar
			echo <<<TXT
<div class='navBar noPrint'>
&nbsp;<div class='floatR'>
<button type='button' onclick="index({cP:20});">{$xx['hdr_button_log_in']}</button>
</div>
</div>\n
TXT;
		}
		echo "<div class='content'>\n";
		if ($pageTitle) echo "<br><h2 class='pageTitle'>{$pageTitle}</h2>\n";
		break;
	case 'a': //admin pages
		echo <<<TXT
<script async src="common/dtpicker.js"></script>
<script async src="common/jscolor.js"></script>
</head>\n
<body onload="scrollY({$opt['cP']},'goto');" onunload="scrollY({$opt['cP']},'save');">\n
TXT;
		headerHdr();
		echo "<div class='navBar noPrint'>\n";
		echo "<div class='floatR'>\n";
		calButton();
		if (!$isMob) { prtButton(); }
		admMenu();
		if (!$isMob) { hlpButton($opt['cP']); }
		logButton();
		echo "</div>\n";
		echo "<div class='floatL'>\n";
		optButton();
		echo "</div>\n";
		echo "<div ".($options ? "class='point noPrint' onclick=\"toggleLabel('optButton','{$xx['options']}','{$xx['done']}'); show('optPanel','optMenu')\"" : '').">&nbsp;</div>\n";
		echo "</div>\n";
		optPanel();
		echo "<div class='content'>\n";
		if ($pageTitle) echo "<br><h2 class='pageTitle'>{$pageTitle}</h2>\n";
		break;
	case 's': //styling window
		echo <<<TXT
<script async src="common/jscolor.js"></script>
</head>\n
<body>
TXT;
		echo "<div class='topBar floatC noPrint'>
<span class='floatL'>{$pageTitle}</span>
<span class='floatR'>\n";
		prtButton();
		hlpButton($opt['cP']);
		echo "</span>
{$set['calendarTitle']}
</div>\n";
		echo "<div class='content'>\n";
		break;
	case 'l': //log in page
		echo <<<TXT
</head>\n
<body>\n
TXT;
		headerHdr();
		echo "<div class='navBar'>\n";
		echo "<div class='floatR'>\n";
		hlpButton($opt['cP']);
		echo "</div>\n";
		echo "&nbsp;</div>\n";
		echo "<div class='content'>\n";
		if ($pageTitle) echo "<br><h2 class='pageTitle'>{$pageTitle}</h2>\n";
		break;
	case 'm': //calendar pages - mobile device
		echo <<<TXT
<script async src="common/dtpicker.js"></script>
</head>\n
<body>\n
<h1>{$set['calendarTitle']}</h1>\n
TXT;
		if ($usr['privs'] > 0) { //view rights
			echo "<div class='navBar noPrint'>\n";
			echo "<div class='floatR'>\n";
			addButton();
			logButton();
			echo "</div>\n";
			urlButton();
			optButton();
			viewButtons();
			dateForm();
			echo "</div>\n";
			optPanel();
		} else { //display dummy navbar
			echo <<<TXT
<div class='navBar noPrint'>
&nbsp;<div class='floatR'>
<button type='button' onclick="index({cP:20});">{$xx['hdr_button_log_in']}</button>
</div>
</div>\n
TXT;
		}
		echo "<div class='content'>\n";
		if ($pageTitle) echo "<br><h2 class='pageTitle'>{$pageTitle}</h2>\n";
		break;
	case 'e': //event window
		echo <<<TXT
<script async src="common/dtpicker.js"></script>
<script>
window.onload = function() {winFit();}
window.onkeyup = function (event) {if (event.keyCode==27) {window.close();}}
</script>
</head>\n
<body>
TXT;
		echo "<div class='topBar noPrint'>\n";
		echo "<div class='floatR'>\n";
		prtButton();
		hlpButton($opt['cP']);
		echo "</div>\n";
		echo "{$pageTitle}\n";
		echo "</div>\n";
		echo "<div class='contentE'>\n";
		break;
	case 'h': //help window
		echo <<<TXT
</head>
<body>
<div class='topBar'>
<span class='floatR select' onclick='self.close();'>&nbsp;&#10060;&nbsp;</span>&nbsp;
{$pageTitle}
</div>
<div class='contentH scroll'>\n
TXT;
}
unset($hdrType);
?>
