//Create HTML5 elements for IE < 9 (see also css.php)

document.createElement("header");
document.createElement("footer");
document.createElement("aside");
document.createElement("mark");

//global variables

var hlpWinH = 500, hlpWinW = 800, hlpWinT = 100; //help window height, width, top
var evtWinH = 200, evtWinW = 510, evtWinT = 100; //event window height, width, top

//shortcut functions

function $I(el) { return document.getElementById(el); }
function $N(el) { return document.getElementsByName(el); }
function $T(el) { return document.getElementsByTagName(el); }
function $C(el) { return document.getElementsByClassName(el); }

//general functions

function help(page,back){ //show user guide. If back, show back button to back
	var hlpWinL = (screen.width-hlpWinW)/2;
	var hlpWin = window.open('','hlpWin','menubar=no,location=no,toolbar=no,height=' + hlpWinH +',width=' + hlpWinW + ',top=' + hlpWinT + ',left=' + hlpWinL + ', scrollbars');
	var parObj = {xP:22,hP:page};
	if (back !== undefined) { parObj.bP = back; }
	index(parObj,'hlpWin');
	hlpWin.focus();
}

function scrollY(cp,par) { //save/restore sBox y-scroll value to/from local storage
	var elm = $I('sBox');
	if(typeof(Storage) !== "undefined" && elm != null) {
		var item = 'sBox'+cp;
		if (par == 'save') { //save y-scroll value
			sessionStorage.setItem(item,elm.scrollTop);
		} else { //goto y-scroll value
			if (sessionStorage.getItem(item) !== "undefined") {
				elm.scrollTop = sessionStorage.getItem(item);
			}
		}
	}
}

function newE(dt,cid,st,et){ //new event - date, cat ID and times (optional)
	var evtWinL = (screen.width-evtWinW)/2;
	var evtWin = window.open('','evtWin','menubar=no,location=no,toolbar=no,height=' + evtWinH +',width=' + evtWinW + ',top=' + evtWinT + ',left=' + evtWinL + ', scrollbars=0');
	var parObj = {xP:30,mode:'add'};
	if (dt != 0) { parObj.evD = dt; }
	if (cid > 0) { parObj.catID = cid; }
	if (arguments.length > 2) { parObj.evTs = st; parObj.evTe = et; }
	index(parObj,'evtWin');
	evtWin.focus();
	return false;
}

function editE(id,date){ //edit event
	var evtWinL = (screen.width-evtWinW)/2;
	var evtWin = window.open('','evtWin','menubar=no,location=no,toolbar=no,height=' + evtWinH + ',width=' + evtWinW + ',top=' + evtWinT + ',left=' + evtWinL + ', scrollbars=0');
	var parObj = {xP:31,mode:'edit',eid:id,evD:date};
	index(parObj,'evtWin');
	evtWin.focus();
	return false;
}

function showE(id,date,cal){ //show event
	var evtWinL = (screen.width-evtWinW)/2;
	var evtWin = window.open('','evtWin','menubar=no,location=no,toolbar=no,height=' + evtWinH + ',width=' + evtWinW + ',top=' + evtWinT + ',left=' + evtWinL + ', scrollbars=0');
	var parObj = {xP:32,eid:id,evD:date};
	if (cal !== undefined) { parObj.cal1x = cal; } //if defined, use cal; but don't store in session
	index(parObj,'evtWin');
	return false;
}

function winFit() { //resize window height to fit its content
  neededIH = document.body.offsetHeight + 6;
  currentIH = window.innerHeight || document.documentElement.clientHeight;
	if (window.resizeBy) {
		window.resizeBy(0,neededIH-currentIH);
	} else {
		currentOW = window.outerWidth;
		currentOH = window.outerHeight;
		window.resizeTo(currentOW,neededIH+currentOH-currentIH);
	}
}

// AJAX functions

function checkE(obj,evtID,evtDt) { //toggle the event check mark
	var xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function() {
		if (xhr.readyState == 4 && xhr.status == 200) {
			if (xhr.responseText != '0') {
				obj.innerHTML = xhr.responseText;
			}
		}
  }
	xhr.open("POST","common/checkevt.php",true);
	xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	xhr.send("evtID="+evtID+"&evtDt="+evtDt);
}

function detach(obj,evtID,fName) { //detach file from event
	var xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function() {
		if (xhr.readyState == 4 && xhr.status == 200) {
			if (xhr.responseText != '0') {
				obj.parentNode.innerHTML = xhr.responseText;
			}
		}
  }
	xhr.open("POST","common/detach.php",true);
	xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	xhr.send("evtID="+evtID+"&fName="+fName);
}

function subCats(catID) { //get subcat data
	var xhr = new XMLHttpRequest();
	xhr.onload = function() {
		if (xhr.status == 200) {
			if (xhr.responseText != '0') {
				var subcats = JSON.parse(xhr.responseText);
				var scHtml = "";
				for (var i = 0; i < subcats.length; i++) {
					style = (subcats[i][1] ? "color:" + subcats[i][1] + ';' : '') + (subcats[i][2] ? "background-color:" + subcats[i][2] + ';' : '');
					scHtml += "<option value='" + (i+1) + "'" + (style ? " style='" + style + "'" : '') + ">" + subcats[i][0] + "</option><br>";
				}
				$I("sid").innerHTML = scHtml;
				$I("scMenu").style.display = "block"; //display subcat menu
			} else {
				$I("scMenu").style.display = "none"; //erase subcat menu
			}
		}
  }
	xhr.open("POST","common/subcats.php",true);
	xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	xhr.send("catID="+catID);
}

//general functions

function index(pars,target) { //dummy form to turn GET into POST
	pars.lcI = 'i'; //internal hit 
	var form = document.createElement("form");
	form.method = "post";
	form.action = "index.php";
	if (target !== undefined) {
		form.target = target;
	}
	for(var key in pars) {
		var inputElm = document.createElement("input");
		inputElm.setAttribute("type","hidden");
		inputElm.setAttribute("name",key);
		inputElm.setAttribute("value",pars[key]);
		form.appendChild(inputElm);
	}
	document.body.appendChild(form);
	form.submit();
}

function done(action) { //close window and refresh calendar (action: c = close; r = reload opener)
	if (action.indexOf('r') > -1) { reload(); } //refresh calendar 
	if (action.indexOf('c') > -1) { window.close(); }
}

function reload() { //refresh calendar
	window.opener.location = window.opener.location.href; //reload
}

function jumpPage(myList,page) {
	var pageObj = new Object();
	if (page < 99) { //normal page
		pageObj.cP = page;
		index(pageObj);
	} else { //styling page (new window)
		myList.selectedIndex = '0'; //reset index
		pageObj.xP = page;
		var styleWin = window.open('','styleWin',"top=100,left=200,width=1000,height=800");
		index(pageObj,'styleWin');
		styleWin.focus();
	}
	return false;
}

function check1(boxName,thisBox,toggle) { //check 1 of N check boxes
	var chBoxes = $N(boxName);
	var checked = thisBox.checked;
	for (var i=(chBoxes.length-1);i >= 0;i--) {
		chBoxes[i].checked = false;
	}
	thisBox.checked = (toggle !== undefined && !checked) ? false : true;
}

function checkZ(boxName,checked) { //check box 0 of N check boxes
	var chBoxes = $N(boxName+'[]');
	for (var i=(chBoxes.length-1);i >= 0;i--) {
		chBoxes[i].checked = false;
	}
	$I(boxName+'0').checked = true;
}

function checkN(boxName,checked) { //check any of N check boxes
	var chBoxes = $N(boxName+'[]');
	var check = false;
	for (var i=(chBoxes.length-1);i >= 0;i--) {
		if (chBoxes[i].checked) { check = true; }
	}
	$I(boxName+'0').checked = (check == true) ? false : true;
}

function checkA(boxName) { //check all check boxes
	var chBoxes = $N(boxName+'[]');
	for (var i=(chBoxes.length-1);i >= 0;i--) {
		chBoxes[i].checked = true;
	}
}

function toggleLabel(optBut,text1,text2) {
	elm = $I(optBut);
	elm.innerHTML = (elm.innerHTML == text1) ? text2 : text1;
}

function showX(elmID,on) { //show or hide element
	if ($I(elmID)) { $I(elmID).style.display = (on ? "block" : "none"); }
}

function showN(elmName) { //show or hide elements
	var elms = $N(elmName);
	var display = elms[0].style.display == "block" ? "none" : "block";
	for (var i=(elms.length-1);i >= 0;i--) {
		elms[i].style.display = display;
	}
}

function show(elmID,formName) { //display/hide element; if form & hide: submit
	var overlay = $I(elmID);
	overlay.style.display = (overlay.style.display == "block") ? "none" : "block";
	if (formName && overlay.style.display == "none") { document.forms[formName].submit(); }
	return false;
}

function hide_times(t) { //toggle visibility of event times
	if (t.checked) {
		$I("dTimeS").style.visibility = "hidden";
		$I("dTimeE").style.visibility = "hidden";
	} else {
		$I("dTimeS").style.visibility = "visible";
		$I("dTimeE").style.visibility = "visible";
		t.form.sti.value = t.form.eti.value = "";
	}
}

function putLocal(elmID) { //save to local storage
	var elm = $I(elmID);
	if(typeof(Storage) !== "undefined") {
		localStorage.elmID = elm.value;
	}
}

function getLocal(elmID) { //get from local storage
	var elm = $I(elmID);
	if (typeof(Storage) !== "undefined") {
		elm.value = localStorage.elmID;
	}
}

function update(jscolor,bgcol,color,bdcol) { //jscolor color changer
	if (bgcol) {
		var bArr = bgcol.split(',');
		for(var i=0; i < bArr.length; i++) {
			$I(bArr[i]).style.backgroundColor = '#'+jscolor;
		}
	}
	if (color) {
		var cArr = color.split(',');
		for(var i=0; i < cArr.length; i++) {
			$I(cArr[i]).style.color = '#'+jscolor;
		}
	}
	if (bdcol) {
		var dArr = bdcol.split(',');
		for(var i=0; i < dArr.length; i++) {
			$I(dArr[i]).style.borderColor = '#'+jscolor;
		}
	}
}

function sml(m1,m2,m3,subject) { //open mail client
	if (confirm(smlConfirm+':\n'+m1+'@'+m2+'.'+m3)) {
		subject = subject.replace(' ','%20');
		location.href='mailto:'+m1+'@'+m2+'.'+m3+'?subject='+subject;
	}
}

//drag functions
var theElm,posX,posY;

function dragMe(elmID,e) {
  theElm = $I(elmID); //object to drag
	if (!e) var e = window.event //if ie
  posX = theElm.offsetLeft - e.clientX;
  posY = theElm.offsetTop - e.clientY;
  document.onmousemove=moveMe;
	document.onmouseup=new Function("theElm=''");
  return false;
}

function moveMe(e) {
	if (!e) var e = window.event //if ie
  if (theElm) {
    theElm.style.left = posX + e.clientX + "px";
    theElm.style.top = posY + e.clientY + "px";
  }
}
//end drag functions

function printNice() {
	var oriHTML = document.body.innerHTML;
	var bgColor = document.body.style.backgroundColor;
	var els = $T("*");
	var regexNP = /noPrint/;
	var regexSB = /scrollBox/;

	document.body.style.backgroundColor = "white";
	for (var i=(els.length-1);i >= 0;i--) {
		if (regexNP.test(els[i].className)) {
			els[i].style.display = "none";
		}
		if (regexSB.test(els[i].className)) {
			els[i].style.position = "static";
			els[i].style.overflow = "visible";
		}
	}
	window.print();
  document.body.innerHTML = oriHTML;
	document.body.style.backgroundColor = bgColor;
	return false;
}

//==== text box popup function ====

function pop(parent,popContent,popClass,popMaxChar){
	var offsetX = -60, offsetY = 16; //x, y offset of box
	var maxLineLen = 80; //default max line length in box
	var popobj;

	var maxBoxWidth = "auto";
	if (typeof popMaxChar == 'number') maxLineLen = popMaxChar;
	var lines = popContent.split("<br>") //split on <br>
	for (var i=0,len=lines.length; i<len; i++) {
		if (lines[i].replace(/(<([^>]+)>)/ig,"").length > maxLineLen) maxBoxWidth = (5 * maxLineLen) + "px";
	}
	if (!$I("htmlPop")) { //pop object not yet existing
		var details = document.createElement("div");
		details.id = "htmlPop";
		document.body.appendChild(details);
	}
	popobj = $I("htmlPop");
	popobj.style.width = maxBoxWidth;
	popobj.className = popClass;
	popobj.innerHTML = popContent;
	popobj.style.visibility = "visible";
	parent.onmousemove = function(e) {
		if (!e) var e = window.event; //if ie
		var rightedge = (!window.innerWidth) ? document.documentElement.clientWidth : window.innerWidth-20; //window edge
		var bottomedge = (!window.innerHeight) ? document.documentElement.clientHeight : window.innerHeight-10;

		if (rightedge-cursorX(e)-offsetX < popobj.offsetWidth) { //if pop hits the right edge
			popobj.style.left = rightedge-popobj.offsetWidth-5+"px"; //don't move it
		} else {
			popobj.style.left = (cursorX(e) < -offsetX) ? "5px" : cursorX(e)+offsetX+"px"; //move it with mouse
		}
		if (bottomedge-cursorY(e)-offsetY < popobj.offsetHeight) { //if pop hits the bottom edge
			popobj.style.top = cursorY(e)-popobj.offsetHeight-(offsetY/2)+"px"; //flip it up
		} else {
			popobj.style.top = cursorY(e)+offsetY+"px"; //move it with mouse
		}
	};
	parent.onmouseout = function() {
		parent.onmousemove = null;
		popobj.style.visibility = "hidden";
	};
	return;
}

//==== compatibility functions ====

function cursorX(e) { //get cursor X-position relative to page
	return e.pageX ? e.pageX : e.clientX + document.documentElement.scrollLeft + document.body.scrollLeft;
}
function cursorY(e) { //get cursor Y-position relative to page
	return e.pageY ? e.pageY : e.clientY + document.documentElement.scrollTop + document.body.scrollTop;
}