<?php
/*
= LuxCal event calendar style sheet =

Copyright 2009-2018 LuxSoft - www.LuxSoft.eu

This file is part of the LuxCal Web Calendar.
*/

header('content-type:text/css');

/* ---- LOAD USER-INTERFACE THEME DEFINITIONS ---- */

//start session
session_name('PHPSESSID');
session_start();
$calID = $_SESSION['cal'];
//switch to calendar specific session
$sessID = session_id();
$sessNM = session_name();
session_write_close();
session_id($sessID.$calID);
session_name($sessNM.$calID);
session_start();
unset($sessID,$sessNM);
if (!empty($_SESSION['theme'])) { //theme file specified
	require "./{$_SESSION['theme']}";
	$theme = $_SESSION['theme'];
} else { //no theme specified, take theme from db
	chdir('../'); //change working directory
	require 'common/toolboxd.php'; //get database tools + LCV
	require 'lcconfig.php'; //get db credentials
	$dbH = dbConnect($calID); //connect to db
	$stH = dbQuery("SELECT `name`,`value` FROM `styles`");
	$th = array();
	while (list($name,$value) = $stH->fetch(PDO::FETCH_NUM)) {
		$th[$name] = $value;
	}
	$theme = 'db theme';
}

//preprocessing
$thHt = $th['PSXXX'] + 6; //height table headers
$buttonHt = intval(($th['MBUTS'] * $th['PSXXX']) + 8); //height buttons
$tInputHt = intval(($th['MFFLD'] * $th['PSXXX']) + 4); //height buttons
$selectHt = intval(($th['MFFLD'] * $th['PSXXX']) + 6); //height buttons
$sBoxHdTp = $th['PSXXX'] + 8; //month/week/day view scrollbox head top
$sBoxTp = $thHt + $sBoxHdTp + 4; //month/week/day view scrollbox top
$navBar  = $th['PTBAR'] + $buttonHt + 16 + $th['sCtOf']; //offset calendar
$offCal = $navBar + 2 + $th['sCtOf']; //offset calendar
$offOpt = $navBar; //offset options panel
$offUpc = $navBar; //offset side bar Upcoming
$offTod = $navBar + 20; //offset side bar Todo
$offToa = $navBar + 40; //offset side bar To approve

//serve styles
echo
// ---- make HTML 5 elements block-level for consistent styling (see also toolbox.js) ----
"/*theme: {$theme}*/

footer, aside {display:block;}
"
.// ---- general: site ----- cursor:default;
"
* {padding:0; margin:0;}
body, select, th, td {font:{$th['PSXXX']}px {$th['FFXXX']};}
a, input, label, select {cursor:pointer;}
input[type='text'], input[type='password'], textarea {font-family:inherit; font-size:{$th['MFFLD']}em; padding:0 2px; color:{$th['CFFLD']}; background:{$th['BFFLD']}; border-radius:2px; border:1px solid #666; cursor:text;}
input[type='text'], input[type='password'] {height:{$tInputHt}px; margin-right:3px;}
button {font-size:{$th['MBUTS']}em; height:{$buttonHt}px; padding:0px 2px; color:{$th['CBUTS']}; background:{$th['BBUTS']}; border-radius:2px; border:1px solid #666; cursor:pointer;}
input[type='radio'], input[type='checkbox'] {vertical-align:middle; margin-right:3px;}
input[type='file'] {font-size:{$th['MBUTS']}em; border-color:#666; background:{$th['BBUTS']};}
input[type='file']:hover, button:hover {border-color:{$th['EBUTS']};}
select {padding:0 2px; font-size:{$th['MFFLD']}em; height:{$selectHt}px; color:{$th['CDROP']}; background:{$th['BDROP']}; border-radius:2px; border:1px solid #666;}
select option {padding: 0 2px;}
body {background:{$th['BXXXX']}; color:{$th['CXXXX']};}
th {height:{$thHt}px; color:{$th['CBHAR']}; background:{$th['BBHAR']}; cursor:default;}
td {vertical-align:top;}
a {color:{$th['CXXXX']}; text-decoration:none;}
a:hover {text-shadow: 0.2em 0.3em 0.2em #F88;}
a.urlembed {font-weight:bold; text-decoration:underline;}
hr {margin:10px 0px; border:1px solid {$th['BBHAR']};}
p {text-align:justify;}
img {border-style:none;}
mark {color:{$th['BHLIT']}; font-weight:bold; text-decoration:underline;}

h1 {font:bold {$th['PTBAR']}px {$th['FFXXX']}; padding:4px 20px;".($th['sTbSw'] ? ' text-shadow: 0.2em 0.3em 0.2em #888;' : '')." text-align:center; color:{$th['CTBAR']}; background:{$th['BTBAR']};}
h2 {font:bold {$th['PPGTL']}px {$th['FFXXX']};}
h3 {font:bold {$th['PTHDL']}px {$th['FFXXX']};}
h4 {font:bold {$th['MTHDM']}em {$th['FFXXX']};}
h5 {font:bold {$th['MDTHD']}em {$th['FFXXX']};}
h6 {font:bold {$th['MSNHD']}em {$th['FFXXX']};}

ul, ol {margin:0 25px;}
li {margin:4px 0;}

.fontS {font-size:{$th['MSMAL']}em;}
.bold {font-weight:bold;}

.floatR {float:right;}
.floatL {float:left;}
.floatC {text-align:center;}
.center {display:block; margin:auto;}
.inline {display:inline;}
.clear {clear:both;}

.point {cursor:pointer;}
.arrow {cursor:default;}
.move {cursor:move;}
.hyper:hover {cursor:pointer; background:{$th['BGCTH']}; overflow:hidden;}
.select:hover {cursor:pointer; background:red;}
.link {text-decoration:underline;}
.pageTitle {margin:0 0 20px 20%;}
.noButton {border:none; background:none; cursor:pointer; text-decoration:underline;}
.confirm {margin:auto; width:70%; text-align:center; color:{$th['CCONF']}; background:{$th['BCONF']};}
.warning {margin:auto; width:70%; text-align:center; color:{$th['CWARN']}; background:{$th['BWARN']};}
.error {margin:auto; width:70%; text-align:center; color:{$th['CERRO']}; background:{$th['BERRO']};}
.inputError {background:{$th['BHLIT']} !important;}
.hilight {margin:10px 0; background:{$th['BHLIT']};}
.hired {color: #FF0000; font-weight: bold;}
.hide {display:none;}
"
.// ---- common ----
"
div.topBar {margin-bottom:10px; padding:0 10px; line-height:20px; font-weight:bold; color:{$th['CBHAR']}; background:{$th['BBHAR']};}
div.navBar {padding:0px 10px;	line-height:20px;	background:{$th['BBHAR']}; border:1px solid {$th['EXXXX']}; border-style:solid none;}
div.content {position:absolute; left:0; top:{$offCal}px; right:0; bottom:30px;}
div.contentE {padding:3px 10px; font-size:{$th['MPWIN']}em;}
div.contentH {position:absolute; left:0; top:30px; right:0; bottom:5px; padding:3px 10px; font-size:{$th['MPWIN']}em; color:{$th['CXWIN']}; background:{$th['BXWIN']};}
footer {position:absolute; left:0; right:0; bottom:10px; padding:0px 10px; font-size:0.8em; background:{$th['BBHAR']}; border:1px solid {$th['EXXXX']}; border-style:solid none; text-align:center;}
.footLB {font:italic bold 1.1em arial,sans-serif; color:#0033FF;}
.footLR {font:italic bold 1.1em arial,sans-serif; color:#AA0066;}
div#toapBar {position: absolute; top:{$offToa}px; right:60px; height:60%; width:200px; padding:4px; border:2px solid {$th['EXXXX']}; border-radius:5px; box-shadow:5px 5px 5px #888; font-size:{$th['MOVBX']}em; color:{$th['COVBX']}; background:{$th['BOVBX']}; background:{$th['BOVBX']}; z-index:22; overflow:hidden; display:none;}
div#todoBar {position: absolute; top:{$offTod}px; right:40px; height:60%; width:200px; padding:4px; border:2px solid {$th['EXXXX']}; border-radius:5px; box-shadow:5px 5px 5px #888; font-size:{$th['MOVBX']}em; color:{$th['COVBX']}; background:{$th['BOVBX']}; z-index:21; overflow:hidden; display:none;}
div#upcoBar {position: absolute; top:{$offUpc}px; right:20px; height:60%; width:200px; padding:4px; border:2px solid {$th['EXXXX']}; border-radius:5px; box-shadow:5px 5px 5px #888; font-size:{$th['MOVBX']}em; color:{$th['COVBX']}; background:{$th['BOVBX']}; z-index:20; overflow:hidden; display:none;}
div.barBody {position:absolute; top:60px; bottom:0px; width:96%; overflow:auto;}
div#optPanel {position:absolute; top:{$offOpt}px; left:10px; padding:4px; border:2px solid {$th['EXXXX']}; border-radius:5px; box-shadow:5px 5px 5px #888; font-size:{$th['MOVBX']}em; color:{$th['COVBX']}; background:{$th['BOVBX']}; z-index:20; overflow:hidden; display:none;}
div.option {float:left; margin:0 2px;}
div.optList {max-height:220px; overflow-y:scroll;}
div.optHead {margin:4px 0; color:{$th['CBHAR']}; background:{$th['BBHAR']};}
"
.// ---- all pages -----
"
.scroll {overflow:auto;}
div.scrollBoxHead {position:absolute; left:0; top:{$sBoxHdTp}px; right:0; padding:0 5px; overflow-y:scroll;}
div.scrollBoxYe {position:absolute; left:0; top:20px; right:0; bottom:0px; padding:0 5px; overflow:auto;}
div.scrollBoxMo, .scrollBoxWe, .scrollBoxDa {position:absolute; left:0; top:{$sBoxTp}px; right:0; bottom:0px; padding:0 5px; overflow-y:scroll;}
div.scrollBoxUp, .scrollBoxCh {position:absolute; left:40px; top:85px; right:0; bottom:0px; padding:0 5px; overflow:auto;}
div.scrollBoxAd {position:absolute; left:40px; top:135px; right:0; bottom:0; padding:0 5px; overflow:auto;}
div.scrollBoxSt {position:absolute; left:0; top:105px; right:0; bottom:0; padding:0 5px; overflow:auto;}
div.scrollBoxMx {position:absolute; left:5px; top:20px; right:5px; bottom:0px; overflow:auto;}
div.calHeadMx {margin-left:180px; text-align:center;}
div.rowBoxMx {position:absolute; left:0; top:0; width:180px;}
div.calBoxMx {position:absolute; left:180px; top:0; right:0; overflow-x:scroll;}

.centerBox {display:table; margin:0 auto;}
.centerBoxFix {width:900px; margin:0 auto;}

table.mgrid td.holder{vertical-align:top; width:16%; padding:2px;}

table.grid {width:100%; border-collapse:collapse; table-layout:fixed;}
table.grid .wkCol {width:25px;}
table.grid .tCol {width:50px;}
table.grid .dCol {}
table.grid .dCol7 {width:14%;}
table.grid .tColBg {background:{$th['BGWTC']};}
table.grid tr.monthWeek {height:120px;}
table.grid tr.yearWeek {height:40px;}
table.grid th {border:1px solid {$th['EXXXX']}; overflow:hidden;}
table.grid td {border:1px solid {$th['EXXXX']}; overflow:hidden;}
table.grid td.wnr {border:none; vertical-align:middle; background:{$th['BGWTC']}; text-align:center;}
table.grid td.we0 {color:{$th['CGWE2']}; background:{$th['BGWE2']};}
table.grid td.we1 {color:{$th['CGWE1']}; background:{$th['BGWE1']};}
table.grid td.wd0 {color:{$th['CGWD2']}; background:{$th['BGWD2']};}
table.grid td.wd1 {color:{$th['CGWD1']}; background:{$th['BGWD1']};}
table.grid td.out {color:{$th['CGOUT']}; background:{$th['BGOUT']};}
table.grid td.blank {border:none; background:rgba(0,0,0,0);}
table.grid td.today {border:1px solid {$th['EGTOD']}; color:{$th['CGTOD']}; background:{$th['BGTOD']};}
table.grid td.slday {border:1px solid {$th['EGSEL']}; color:{$th['CGSEL']}; background:{$th['BGSEL']};}

table.matrix {width:100%; border-collapse:collapse; table-layout:fixed;}
table.matrix th.month {text-align:left; font-weight:bold;}
table.matrix th.rowName {font-weight:bold;}
table.matrix tr {height:46px;}
table.matrix tr.headMx {height:20px;}
table.matrix col {width:42px;}
table.matrix td {border:1px solid {$th['EXXXX']}; overflow:hidden;}
table.matrix td.rowName {padding:5px;}
table.matrix td.we {background:{$th['BGWE1']};}
table.matrix td.wd {background:{$th['BGWD2']};}
table.matrix td.today {border:1px solid {$th['EGTOD']}; background:{$th['BGTOD']};}
table.matrix td.slday {border:1px solid {$th['EGSEL']}; background:{$th['BGSEL']};}

iframe.csHelp {width:100%; height:100%; border:none;}
"
.// -- view: all --
"
.viewHdr {display:inline-block; min-width:350px;}
.arrowLink {padding:0 20px;}
.chkBox {color:{$th['CCHBX']}; background:{$th['BCHBX']}; padding-right:2px;}
.chkBox:hover {background:{$th['BGCTH']};}
"
.// -- view: year/month --
"
.square {float:left; width:8px; height:8px; border:1px solid {$th['EXXXX']};}
.event {margin:2px;}
.evtTitle {display:block; font-size:{$th['MEVTI']}em;}
.dom1 {padding:0 2px; color:{$th['CGTFD']}; background:{$th['BGTFD']};}
.dom {padding:0 2px; color:{$th['CGTFD']};}
.firstDom {padding:0 2px; color:{$th['CGTFD']}; background:{$th['BGTFD']};}
.wnr {color:{$th['CGWTC']};}
.thNail {max-width: 100%;}
"
.// -- view: week/day/dw_functions --
"
var {display:block; border:1px solid {$th['EXXXX']}; border-style:none none solid none;}
.day ul {margin:5px; padding:0px 15px;}
.timeFrame {position:relative;}
.times {border:1px solid {$th['EXXXX']}; border-style:none none solid none; text-align:center; color:{$th['CGWTC']};}
.dates {position:absolute; left:0px; top:0px; width:100%;}
.evtBox {position:absolute; border:1px solid {$th['EXXXX']}; z-index:1; overflow:hidden; border-radius: 5px; box-shadow: 10px 10px 25px grey;}
.dwEvent {margin-top:2px;}
.dwEventNw {margin-top:2px; white-space: nowrap}
"
.// -- view: upcoming / changes / search --
"
div.subHead {width:80%; margin:20px 40px 0px 40px}
td.widthCol1 {width:120px;}
td.eBox {padding-left:5px;}
"
.// -- event window --
"
table.evtForm {width:100%; padding:5px; margin:0 0 10px 0; border-spacing:4px; color:{$th['CXWIN']}; background:{$th['BXWIN']};}
table.evtForm col.col1 {width:80px;}
table.evtForm col.col2 {width:120px;}
table.evtForm col.col3 {width:120px;}
div.apdBar {text-align:center; margin: 4px 0; font-weight:bold;}
div.repBox {position:absolute; left:30px; bottom:135px; padding:10px; border:2px solid {$th['EXXXX']}; border-radius:5px; box-shadow:5px 5px 5px #888; font-size:{$th['MOVBX']}em; color:{$th['COVBX']}; background:{$th['BOVBX']}; z-index:20; display:none;}
"
.// ---- log-in page ----
"
div.loginBox {width:350px; margin:50px auto; padding:30px; border:2px solid {$th['EXXXX']}; border-radius:5px; box-shadow:5px 5px 5px #888; font-size:{$th['MOVBX']}em; color:{$th['CINBX']}; background:{$th['BINBX']};}
"
.// ---- admin pages -----
"
fieldset {width:auto; margin-bottom:10px; padding:20px; border:1px solid #888888; background:{$th['BINBX']}; border-radius:5px;}
legend {font-weight:bold; padding: 0 5px; background:{$th['BINBX']};}
table.list {border-spacing:4px; white-space:nowrap}
.takeRest {width:100%;}
.stylesL {display:inline-block; float:left; cursor:default; vertical-align:top;}
.stylesR {display:inline-block; float:right; cursor:default; vertical-align:top;}
.style {margin:6px 12px;}
.setting {cursor:default; margin-bottom: 2px;}
.sLabel {display:inline-block; width:320px; text-align:right; margin-right: 6px;}
.label {cursor:default; text-align:right; padding:0 6px 0 0;}
.aside {width:35%; margin:0 10px 10px 0; padding:5px; border:1px solid {$th['EXXXX']}; border-radius:5px; box-shadow:5px 5px 5px #888; font-size:{$th['MOVBX']}em; color:{$th['COVBX']}; background:{$th['BOVBX']}; float:right;}
.butHead {margin:20px auto 10px auto;}
.saveSettings {display:block; margin:25px auto 10px auto;}
"
.// ---- Onmouseover popup Styles (toolbox.js poptext) ----
"
div#htmlPop {position:absolute; width:150px; font-size:{$th['MPOPU']}em ; padding:4px; border-radius:5px; box-shadow:5px 5px 5px #888; visibility:hidden; z-index:10;}
.normal {border:1px solid {$th['EHNOR']}; color:{$th['CHNOR']}; background:{$th['BHNOR']};}
.private {border:1px solid {$th['EHPRI']}; color:{$th['CHPRI']}; background:{$th['BHPRI']};}
.repeat {border:1px solid {$th['EHREP']}; color:{$th['CHREP']}; background:{$th['BHREP']};}
"
.// ---- Date Picker Styles -----
"
.dpTable {width:150px; font:12px arial,sans-serif; text-align:center; color:#505050; background:{$th['BINBX']}; border:2px outset white;}
.dpTable th {	background:{$th['BBHAR']}; color:{$th['CXXXX']};}
.dpTD {border:1px solid {$th['BINBX']};}
.dpTDHover {border:1px solid #888888; cursor:pointer; color:red;}
.dpHilight {border:1px solid #888888; color:red; font-weight:bold;}
.dpTitle {font:bold 12px arial,sans-serif; color:{$th['CXXXX']};}
.dpButton {font:bold 10px arial,sans-serif; color:{$th['CBUTS']}; background:{$th['BBUTS']}; cursor:pointer;}
"
.// ---- Time Picker Styles -----
"
.tpFrame {width:155px; overflow:hidden; font:11px/12px arial,sans-serif; text-align:center; color:#505050; background:#F2F2F2; border:1px solid #AAAAAA;}
.tpAM {background:#EEFFFF;}
.tpPM {background:#FFCCEE;}
.tpEM {background:#DDFFDD;}
.tpPick:hover {background:#A0A0A0; color:red;}
"
?>
