<?php
/* LuxCal display1 © 2009-2018 LuxSoft www.LuxSoft.eu*/$LDV='2018-01-31';
/*----------------------------- MUST READ --------------------------------
This file is part of the LuxCal Calendar and is distrubuted WITHOUT ANY 
WARRANTY. See the GNU General Public License for details.

This LuxCal display is best viewed in an iframe with a reduced width.
Images in Extra field 1 float left, images in Extra field 2 float right
If an Extra field contains an image and a URL, the image will become a 
URL link.

This display must be run from the calendar's root directory!

----------- The following settings / colors can be edited ------------
------ only edit the part on the right side of the equal sign ------*/

//SET START AND END DATE
//Possible values: A fixed date (yyyy-mm-dd), or one of the keywords DAY, WEEK, MONTH, YEAR, optionally followed by an multiplication factor
//Examples $fromDate: "2018-01-28" | "DAY-2": today - 2 days | "WEEK": start of this week | "MONTH+1": start of next month | "YEAR": start of this year
//Examples $tillDate: "2018-06-14" |  "DAY+2": today + 2 days | "MONTH": end of this month | "MONTH+1": end of next month | "YEAR": end of this year
$fromDate = "DAY"; //from date 
$tillDate = "MONTH+1"; //till date

//GENERAL SETTINGS
$calID = "mycal"; //calendar to use (between the quotes: specify the ID of the calendar. Blank (""): the default calendar) 
$sortD = 0; //sorting on dates; 0: ascending, 1: descending
$maxDays = 0; //max. number of days to show; 0: no maximum
$maxEvts = 0; //max. number of events to show per day; 0: no maximum
$futEvts = 0; //show ongoing and future events only (0: no, 1: yes). Note: This setting overrules the "from date" and sets it to "DAY"
$header = "My Web Calendar"; //optional display header. Blank (""): no header
$evtBody = '345'; //event fields to show (list of numbers: 1: venue, 2: category, 3: description, . . . for more see Settings page - Event templates)
$evtWin = 1; //on click open event window (0: no, 1: yes). If the user has post rights, the event add/edit window will open, otherwise the event report window will open
$showDt = 0; //show the date before each event title (0: no, 1: yes)
$showTm = 1; //show the time before each event title (0: no, 1: yes)
$recOnce = 0; //for recurring events, show only one (the next) occurrence (0: all, 1: next only)
$mulOnce = 0; //for multi-day events, show only one (the next) occurrence (0: all, 1: next only)
$maxImgH = 80; //maximum height of images (in pixels)

//FILTERS
$groups = "0"; //events in groups to show (comma separated list of group IDs; 0: all groups)
$users = "0"; //events of users to show (comma separated list of user IDs; 0: all users)
$cats = "0"; //events in categories to show (comma separated list of cat IDs; 0: all categories)
$venue = ""; //case-insensitive text string to be present in venue. Blank (""): no filter 

//COLORS
$BGENL = "#F0F0F0"; //general background color
$BBORD = "#F0F0F0"; //container background color
$CBORD = "#444444"; //container border color
$BDATE = "#FEAC10"; //calendar date background color
$CDATE = "#666666"; //calendar date text color
$CHEAD = "#444444"; //header text color
$BEVNT = "#DDDED2"; //event background color
$CTITL = "#990000"; //event title color
$CDESC = "#202030"; //event description color
$CDATI = "#990000"; //event date/time color
$CLINK = "#222288"; //URL link color

//MARGINS/BORDERS in pixels
$MOUTR = "10"; //container outer margin
$MINNR = "20"; //container inner margin
$WBORD = "4"; //container border width

//FONT FAMILIES
$FHEAD = "arial,sans-serif"; //header
$FDATE = "tahoma, arial, sans-serif"; //date
$FETIT = "arial, sans-serif"; //event title
$FEVNT = "arial,sans-serif"; //event

//FONT SIZES in em (x 12px)
$SHEAD = "2.0"; //header (if specified)
$SDATE = "2.0"; //date
$SETIT = "1.3"; //event title
$SEVNT = "1.2"; //event font

/*--------------------------------------------------------------------*/

function showEvents($date) {
	global $calID, $evtList, $evtBody, $showDt, $showTm, $maxEvts, $futEvts, $evtWin, $xx, $rxULink, $rxIMGTags;

	$maxE = $maxEvts;
	$now = date('Y-m-dH:i');
	foreach ($evtList[$date] as $evt) {
		if ($futEvts and $evt['eti'] and $date.$evt['eti'] < $now) { continue; } //future events only
		$evtD = $showDt ? makeD($date,4) : '';
		if ($showTm) {
			switch ($evt['mde']) { //multi-day event?
				case 0: $evtT = $evt['ald'] ? $xx['vws_all_day'] : ITtoDT($evt['sti']).($evt['eti'] ? ' - '.ITtoDT($evt['eti']) : ''); break; //no
				case 1: $evtT = ($evt['sti'] != '00:00' and $evt['sti'] != '') ? $xx['from']." ".ITtoDT($evt['sti']) : $xx['vws_all_day']; break; //first
				case 2: $evtT = $xx['vws_all_day']; break; //in between
				case 3: $evtT = ($evt['eti'] < '23:59' and $evt['eti'] != '') ? $xx['until']." ".ITtoDT($evt['eti']) : $xx['vws_all_day']; //last
			}
		} else {
			$evtT = '';
		}
		$sep = ($showDt and $showTm) ? ' - ' : '';
		$chBox = '';
		if ($evt['cbx']) {
			$chBox .= strpos($evt['chd'], $date) ? $evt['cmk'] : '&#x2610;';
			$chBox = "<span title='{$evt['clb']}' class='chkBox'>{$chBox}</span>";
		}
		if ($evtWin) {
			$onClick = " onclick=\"".($evt['mayE'] ? 'editE' : 'showE')."({$evt['eid']},'{$date}','{$calID}');\""; //view or post/edit 
			$cursor = ' point';
		} else {
			$onClick = '';
			$cursor = ' arrow';
		}
		echo "<div class='event'>\n";
		if (preg_match($rxIMGTags,$evt['xf1'],$img)) { //image found
			if (preg_match($rxULink,$evt['xf1'],$url)) { //url
				echo "<span class='imageL'><a href='{$url[1]}' target='_blank'>{$img[0]}</a></span>\n";
			} else { //no url
				echo "<span class='imageL'>{$img[0]}</span>\n";
			}
		}
		if (preg_match($rxIMGTags,$evt['xf2'],$img)) {
			if (preg_match($rxULink,$evt['xf2'],$url)) { //url
				echo "<span class='imageR'><a href='{$url[1]}' target='_blank'>{$img[0]}</a></span>\n";
			} else { //no url
				echo "<span class='imageR'>{$img[0]}</span>\n";
			}
		}
		$datim = ($showDt or $showTm) ? "<span class='datim'>{$evtD}{$sep}{$evtT} </span>" : '';
		echo "{$chBox}<div class='title{$cursor}'{$onClick}>{$datim}{$evt['tit']}</div>\n";
		echo "<span class='descr'>".makeE($evt,$evtBody,'br',"<br>")."</span>\n";
		echo "</div>\n";
		if (--$maxE == 0) { break; }
	}
}

error_reporting(E_ERROR); //errors only
//error_reporting(E_ALL); //errors, warnings and notices - test line

//get config data
if (file_exists('./lcconfig.php')) {
	require './lcconfig.php';
} else {
	exit('No config data!');
}

require './common/toolbox.php'; //load tools
require './common/toolboxd.php'; //database tools
require './common/retrieve.php'; //get retrieve function

if (empty($calID)) { $calID = $dbDef; } //select calendar

$dbH = dbConnect($calID); //connect to database

$set = getSettings(); //get settings from db

date_default_timezone_set($set['timeZone']); //set time zone

header("Cache-control: private"); //proxies: don't cache

require './lang/ui-'.strtolower($set['language']).'.php'; //set language

$stH = dbQuery("SELECT u.`ID`, g.`privs`, g.`vCatIDs` as vCats, g.`eCatIDs` as eCats FROM `users` AS u INNER JOIN `groups` AS g ON g.`ID` = u.`groupID` WHERE u.`ID` = 1");
$usr = $stH->fetch(PDO::FETCH_ASSOC); //user & group data
$stH = null; //release statement handle!

//compute from date
$fromDate = str_replace(' ','',$fromDate);
if (preg_match('~^\d{2,4}[\./-]\d{2}[\./-]\d{2}$~i',$fromDate,$match)) { //fixed from date
	$fStamp = mktime(12,0,0,substr($fromDate,5,2),substr($fromDate,8,2),substr($fromDate,0,4)); //current Unix time
} elseif (preg_match('~^(DAY|WEEK|MONTH|YEAR)([+-]\d{1,4})?$~i',$fromDate,$match)) { //parse from date
	$mult = !empty($match[2]) ? intval($match[2]) : 0;
	switch (strtoupper($match[1])) { //compute from date
	case 'DATE':
		break;
	case 'DAY':
		$fStamp = mktime() + ($mult * 86400); //time first day
		break;
	case 'WEEK':
		$fStamp = mktime() - ((date('w') - $set['weekStart']) * 86400) + ($mult * 604800); //time first day
		break;
	case 'MONTH':
		$fMonth = date('n') + $match[2]; //current month + offset
		$fStamp = mktime(12,0,0,$fMonth,1,date('Y')); //time first day of from month
		break;
	case 'YEAR':
		$fStamp = mktime(12,0,0,1,1,date('Y') + $mult); //time first day of from year
	}
} else {
	echo 'Error in $fromDate'; exit;
}

if ($futEvts) { //future events only
	$fStamp = mktime(); //from date is today
}

//compute till date
$tillDate = str_replace(' ','',$tillDate);
if (preg_match('~^\d{2,4}[\./-]\d{2}[\./-]\d{2}$~i',$tillDate,$match)) { //fixed till date
	$tStamp = mktime(12,0,0,substr($tillDate,5,2),substr($tillDate,8,2),substr($tillDate,0,4)); //current Unix time
} elseif (preg_match('~^(DAY|WEEK|MONTH|YEAR)([+-]\d{1,4})?$~i',$tillDate,$match)) { //parse till date
	$mult = !empty($match[2]) ? intval($match[2]) : 0;
	switch (strtoupper($match[1])) { //compute till date
	case 'DAY':
		$tStamp = mktime() + ($mult * 86400); //time last day
		break;
	case 'WEEK':
		$tStamp = mktime() + ((6 - date('w') + $set['weekStart']) * 86400) + ($mult * 604800); //time first day
		break;
	case 'MONTH':
		$tMonth = date('n') + $match[2]; //current month + offset
		$tStamp = mktime(12,0,0,$tMonth,1,date('Y')) + ((date('t',$tMonth) - 1) * 86400); //time last day of till month
		break;
	case 'YEAR':
		$tStamp = mktime(12,0,0,1,0,date('Y') + $mult + 1); //time last day of till year (next year -1 day)
	}
} else {
	echo 'Error in $tillDate'; exit;
}

//set filter
$usr['vCats'] = empty($cats) ? '0' : $cats; //categories to show
$usr['eCats'] = '0'; //all cat edit rights
$filter = ''; //init
if (!empty($groups)) { $filter .= " AND g.`ID` IN ({$groups})"; }
if (!empty($users)) { $filter .= " AND e.`userID` IN ({$users})"; }
if (!empty($venue)) { $filter .= " AND e.`venue` LIKE '%{$venue}%'"; }
if ($filter) { $filter = substr($filter,5); }

$evtList = array(); //init
retrieve(date('Y-m-d', $fStamp),date('Y-m-d', $tStamp),'',$filter); //retrieve events

if ($sortD) {
	krsort ($evtList);
}
?>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<title><?php echo $set['calendarTitle']; ?></title>
<meta name="description" content="LuxCal web calendar - a LuxSoft product">
<meta name="application-name" content="LuxCal V<?php echo LCV.' Display1 V'.$LDV?>">
<meta name="author" content="Roel Buining">
<meta name="robots" content="nofollow">
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="canonical" href="<?php echo $set['calendarUrl']; ?>">
<script src="common/toolbox.js"></script>
<style type="text/css">
<?php
$hdrMarginH = $MOUTR + $MINNR + $WBORD;
$calTop = $header ? $MOUTR + ($SHEAD * 12) + 10 : $MOUTR;
 echo "
* {padding:0; margin:0;}
body {font-size:12px; background: {$BGENL}; overflow:hidden; cursor:default;}
a {color:{$CLINK}; text-decoration:none; cursor:pointer;}
a:hover {text-shadow: 0.2em 0.3em 0.2em {$CLINK};}
img {max-height:{$maxImgH}px;}
.center {text-align:center;}
.point {cursor:pointer;}
div.header {font:bold {$SHEAD}em {$FHEAD}; color:{$CHEAD}; margin:{$MOUTR}px {$hdrMarginH}px;}
div.container {position:absolute; top:{$calTop}px; right:{$MOUTR}px; bottom:{$MOUTR}px; left:{$MOUTR}px; padding:{$MINNR}px; overflow:auto; border:{$WBORD}px {$CBORD}; border-style:solid;}
table.calendar {width:100%; border-collapse:collapse; background:{$BBORD};}
table.calendar td {vertical-align:top; border:6px solid white;}
td.date {font:{$SDATE}em {$FDATE}; width:15%; color:{$CDATE}; background:{$BDATE};}
td.eBox {font:{$SEVNT}em {$FEVNT}; width:85%; padding:5px 10px; background:{$BEVNT};}
div.event {margin:0 0 4px 0; text-align:justify; text-justify:inter-word;}
.title {font:{$SETIT}em {$FETIT}; color:{$CTITL}; margin:4px 0;}
.descr {color:{$CDESC};}
.datim {color:{$CDATI};}
.imageL {float:left; margin: 0px 10px 10px 0px;}
.imageR {float:right; margin: 0px 0px 10px 10px;}
.chkBox {float:left; color:{$CTITL}; background:{$BEVNT}; padding-right:2px;}
"
?>
</style>
</head>

<body>
<?php
//display calendar
if ($header) { echo "<div class='header'>{$header}</div>\n"; }
echo "<div class='container'>\n";
echo "<table class='calendar'>\n";
$evts1x = array(); //init
foreach ($evtList as $cDate => &$events) { //loop thru dates
	foreach ($events as $k => $evt) { //loop thru events
		if (($evt['r_t'] and $recOnce) or ($evt['mde'] and $mulOnce)) { //remove recurring and/or multi-day event multiples
			if (in_array($evt['eid'],$evts1x)) {
				unset($events[$k]);
			} else {
				$evts1x[] = $evt['eid'];
			}
		}
	}
	if (empty($events)) { continue; } //no events left for this date
	$cDay = ltrim(substr($cDate,8,2),'0');
	$cMonth = intval(substr($cDate,5,2));
	$cDayNr = date('w',mktime(12,0,0,substr($cDate,5,2),substr($cDate,8,2),substr($cDate,0,4)));
	if ($evtWin and $usr['privs'] > 1) {
		$onclick = " onclick=\"newE('{$cDate}',0);\" title='{$xx['vws_add_event']}'";
		$cursor = ' point';
	} else {
		$onclick = $cursor = '';
	}
	echo "<tr>\n";
	echo "<td class='date center{$cursor}'{$onclick}>{$wkDays[$cDayNr]}<br>{$cDay} {$months_m[$cMonth - 1]}</td>\n";
	echo "<td class='eBox'>\n";
	showEvents($cDate); //show events for this date
	echo "</td>\n";
	echo "</tr>\n";
	if (--$maxDays == 0) { break; }
}
echo "</table>\n";
echo "</div>\n";
?>
</body>
</html>
