<?php
/*
= view calendar changes (added / edited / deleted events) since specified date =

 Copyright 2009-2018 LuxSoft - www.LuxSoft.eu

This file is part of the LuxCal Web Calendar.

The LuxCal Web Calendar is free software: you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software Foundation, 
either version 3 of the License, or (at your option) any later version.

The LuxCal Web Calendar is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the LuxCal 
Web Calendar. If not, see: http://www.gnu.org/licenses/.
*/

require './common/retrieve2.php';

function showEvents(&$events,$date) {
	global $wkDays, $set, $eDetails, $xx, $months;
	
	foreach ($events as $evt) {
		$repTxt = repeatText($evt['r_t'],$evt['r_i'],$evt['r_p'],$evt['r_m'],$evt['r_u']); //make repeat text
		if ($evt['app'] and !$evt['apd']) { $eBoxStyle = 'border-left:2px solid #ff0000;'; }
		$eBoxStyle = !empty($eBoxStyle) ? " style='{$eBoxStyle}'" : '';
		$dateTime = makeFullDT(true,$evt['sda'],$evt['eda'],$evt['sti'],$evt['eti']); //make full date/time
		if ($repTxt) { $dateTime .= " ({$repTxt})\n"; } //add repeat text
		if ($set['eventColor']) {
			$eStyle = ($evt['cco'] ? "color:{$evt['cco']};" : '').($evt['cbg'] ? "background-color:{$evt['cbg']};" : '');
		} else {
			$eStyle = $evt['uco'] ? "background-color:{$evt['uco']};" : '';
		}
		$eStyle = $eStyle ? " style='{$eStyle}'" : '';
		echo "<table>\n<tr>
			<td class='widthCol1'>".(($evt['sts'] < 0) ? $xx['chg_deleted'] : ($evt['mdt'] > $evt['adt'] ? $xx['chg_edited'] : $xx['chg_added']))."</td>\n";
		echo "<td class='eBox'{$eBoxStyle}>{$dateTime}";
		if ($evt['sts'] >= 0 and ($eDetails or $evt['mayE'])) {
			$click = ($evt['mayE'] ? 'editE' : 'showE')."({$evt['eid']},'{$date}')";
			echo "<span class='point evtTitle bold'{$eStyle} onclick=\"{$click};\">{$evt['tix']}</span>\n";
		} else {
			echo "<span class='evtTitle bold'{$eStyle}>{$evt['tix']}</span>\n";
		}
		if ($eDetails or $evt['mayE']) {
			echo makeE($evt,$set['evtTemplGen'],'br',"<br>\n")."\n";
		}
		echo "</td>\n</tr>\n</table>\n<br>\n";
	}
}

//sanity check
if (empty($lcV)) { exit('not permitted ('.substr(basename(__FILE__),0,-4).')'); } //launch via script only

//main program
$evtList = array();
$fromD = (isset($_POST['fromD'])) ? DDtoID($_POST['fromD']) : date('Y-m-d');
$fromD = min($fromD, date('Y-m-d'));

//display header
echo "<div class='subHead'>
	<form id='selectD' name='selectD' action='index.php' method='post'>{$xx['chg_from_date']}: 
	<input type='hidden' name='lcI' value='{$lcI}'>
	<input type='text' id='fromD' name='fromD' value='".IDtoDD($fromD)."' size='10'>
	<button class='noPrint' title=\"{$xx['chg_select_date']}\" onclick=\"dPicker(0,'selectD','fromD');return false;\">&larr;</button>
	</form>
</div>\n";

// retrieve changed events
grabChanges($fromD,0); //query db for changes

//display changes
echo "<div class='eventBox".($isMob ? "'" : " scrollBoxCh' id='sBox'").">\n";
if ($fromD != date('Y-m-d')) {
	echo "<h5>".makeD($fromD,2)." - ".makeD(date('Y-m-d'),2)."</h5>\n<br>\n";
}
if ($evtList) {
	foreach($evtList as $date => &$events) {
		echo "<br><h5>".$xx['chg_changed_on']." ".makeD($date,5)."</h5><br>\n";
		showEvents($events,$date);
	}
} else {
	echo "<br>{$xx['chg_no_changes']}<br>\n";
}
echo "</div>\n<br>";
?>
