<?php
/*
= users matrix view of events =

 Copyright 2009-2018 LuxSoft - www.LuxSoft.eu

This file is part of the LuxCal Web Calendar.

The LuxCal Web Calendar is free software: you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software Foundation, 
either version 3 of the License, or (at your option) any later version.

The LuxCal Web Calendar is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the LuxCal 
Web Calendar. If not, see: http://www.gnu.org/licenses/.
*/

function showEvents($date,$uID) {
	global $evtList, $usr, $set, $eDetails, $xx;

	foreach ($evtList[$date] as $evt) {
		if ($evt['uid'] != $uID) { continue; }
		$time = makeHovT($evt);
		$chBox = '';
		if ($evt['cbx']) {
			$chBox .= strpos($evt['chd'],$date) ? $evt['cmk'] : '&#x2610;';
			$chBox = "<span class='chkBox'>{$chBox}</span>";
		}
		if ($set['evtTemplPop']) {
			$popText = "<b>{$chBox} {$time} {$evt['tix']}</b><br>";
			if ($eDetails or $evt['mayE']) {
				$popText .= makeE($evt,$set['evtTemplPop'],'br','<br>');
			}
			$popText = htmlspecialchars(addslashes($popText));
			$popClass = ($evt['pri'] ? 'private' : 'normal').(($evt['mde'] or $evt['r_t']) ? ' repeat' : '');
			$popAttr = " onmouseover=\"pop(this,'{$popText}','{$popClass}')\"";
		} else {
			$popAttr = '';
		}
		$bgColor = $set['eventColor'] ? $evt['cbg'] : $evt['uco'];
		$style = $bgColor ? " style='background-color:{$bgColor};'" : '';
		$class = $evt['sym'] ? 'symbol' : 'square';
		$class .= ($evt['app'] and !$evt['apd']) ? ' aBorder' : '';
		$click = ($evt['mayE'] ? 'editE' : 'showE')."({$evt['eid']},'{$date}')";
		$onClick = ($eDetails or $evt['mayE']) ? "class='{$class} point'{$style} onclick=\"{$click};\"" : "class='{$class} arrow'{$style}";
		echo "<div {$onClick}{$popAttr}>{$evt['sym']}</div>\n";
	}
}

//sanity check
if (empty($lcV)) { exit('not permitted ('.substr(basename(__FILE__),0,-4).')'); } //launch via script only

//initialize
$evtList = array();
$daysToShow = $set['XvWeeksToShow'] * 7;
$uxTime = mktime(12,0,0,substr($opt['cD'],5,2),substr($opt['cD'],8,2),substr($opt['cD'],0,4)); //current time
$dayNr = date('w',$uxTime); //0:Su - 6:Sa

//set the start and end date of the calendar period to show
$sTime = $uxTime - ((($dayNr - $set['weekStart'] + 7) % 7) * 86400); //calendar start time
$sDate = date('Y-m-d',$sTime); //cal start date
$eDate = date('Y-m-d',$sTime + (($daysToShow - 1) * 86400)); //cal end date

$prevDate = date("Y-m-d",$sTime - (($daysToShow - 14) * 86400));
$nextDate = date("Y-m-d",$sTime + (($daysToShow) * 86400));

//get users

$filter = ''; //user filter
if (count($opt['cU']) > 0 and $opt['cU'][0] != 0) {
	$filter .= "u.`ID` IN (".implode(",",$opt['cU']).") AND ";
}
if (count($opt['cG']) > 0 and $opt['cG'][0] != 0) {
	$filter .= "g.`ID` IN (".implode(",",$opt['cG']).") AND ";
}
$stH = dbQuery("SELECT u.`ID`, u.`name`, g.`color` 
	FROM `users` AS u
	INNER JOIN `groups` AS g ON g.`ID` = u.`groupID`
	WHERE {$filter}u.`status` >= 0
	ORDER BY u.`name`");
$users = $stH->fetchAll(PDO::FETCH_ASSOC); //2-dim array

if (count($users) == 0) {
	echo "<div class='scrollBoxMx'><h3>{$xx['vws_no_users']}</h3></div>";
	goto end;
}

//retrieve events
retrieve($sDate,$eDate,'guc');

//display header
$dateHdr = '<span'.($isMob ? '' : ' class="viewHdr"').'>'.makeD($sDate,3)." - ".makeD($eDate,3).'</span>';
$arrowL = "<a class='noPrint arrowLink' href=\"javascript:index({cD:'{$prevDate}'})\">&#9664;</a>";
$arrowR = "<a class='noPrint arrowLink' href=\"javascript:index({cD:'{$nextDate}'})\">&#9654;</a>";
echo "<div class='calHeadMx'>\n<h5>{$arrowL}{$dateHdr}{$arrowR}</h5>\n</div>";

//display matrix - users
echo '<div'.($isMob ? '' : " class='scrollBoxMx' id='sBox'").">\n";
echo "<div class='rowBoxMx'>\n";
echo "<table class='matrix'>\n";
echo "<tr class='headMx'><th>\n";
if (strpos($avViews,'9') !== false) {
	echo	"<form method='post' action=\"javascript:index({cP:9});\">
<input type='hidden' name='lcI' value='{$lcI}'>
<button type='submit' name='back' value='y'>{$xx['vws_evt_cats']}</button>
</form>";
}
echo"</th>\n</tr>\n";
echo "<tr class='headMx'><th class='rowName'>{$xx['vws_cal_users']}</th></tr>\n";
foreach($users as $user) {
	$style = $user['color'] ? " style='background-color:{$user['color']};'" : '';
	echo "<tr>\n<td class='rowName'{$style}>{$user['name']}</td>\n</tr>\n";
}
echo "</table>\n</div>\n";

//display matrix - calendar days
//calendar
echo "<div class='calBoxMx'>\n";
echo "<table class='matrix'>\n";
echo "<col span='{$daysToShow}'>\n";
//calendar months
echo "<tr class='headMx'>\n";
$cTime = $sTime;
for($i = 0; $i < $daysToShow; $i++) {
	$dx = date('j',$cTime); //day of month (1 - 31)
	$dxNext = date('j',$cTime+86400);
	$mx = date('n',$cTime); //month (1 - 12)
	if($dx == 1 or $dx == 15 or ($i == 0 and $dxNext != '1' and $dxNext != '15')) {
		echo "<th class='month'>".$months[$mx-1]."</th>\n";
	} else {
		echo "<th></th>\n";
	}
	$cTime += 86400; //+1 day
}
echo "</tr>\n";
//calendar week days
echo "<tr class='headMx'>\n";
for($i=$set['weekStart']; $i < ($set['weekStart']+$daysToShow); $i++) {
	echo "<th>{$wkDays_s[$i%7]}</th>"; //week days
}
echo "</tr>\n";
//calendar body
foreach($users as $user) {
	echo "<tr>\n";
	for($i=0; $i < $daysToShow; $i++){ //number of days to show
		$cTime = $sTime + ($i * 86400);
		$cDate = date("Y-m-d",$cTime);
		$day = ltrim(substr($cDate,8,2),"0");
		$dayBg = '';
		if (!empty($evtList[$cDate])) { //check if day background should be set
			foreach ($evtList[$cDate] as $evt) {
				if ($evt['uid'] == $user['ID'] and ($evt['dbg'] & 1)) {
					$dayBg = " style='background:{$evt['cbg']}'";
				}
			}
		}
		$dow = strpos($set['workWeekDays'],date("w",$cTime)) === false ? 'we' : 'wd';
		if ($cDate == date("Y-m-d")) {
			$dow .= ' today';
		} elseif ($cDate == $nD) {
			$dow .= ' slday';
		}
		if (!$cH) {
			$day = "<span class='dom floatR'>{$day}</span>";
		} else {
			$day = "<span class='dom floatR hyper' onclick=\"index({cP:6,cD:'{$cDate}'});\" title=\"{$xx['vws_view_day']}\">{$day}</span>";
		}
		$cid = (count($opt['cC']) == 1 and $opt['cC'][0] != 0) ? $opt['cC'][0] : 0;
		$dHead = ($usr['privs'] > 1) ? " class='hyper' onclick=\"newE('{$cDate}',{$cid});\" title=\"{$xx['vws_add_event']}\"" : '';
		echo "<td class='{$dow}'{$dayBg}>{$day}<div{$dHead}>&nbsp;</div>\n";
		if (!empty($evtList[$cDate])) { showEvents($cDate,$user['ID']); }
		echo "</td>\n";
	}
	echo "</tr>\n";
}
echo "</table>\n</div>\n</div>\n";
end:
?>
