<?php
/*
= upcoming events view =

 Copyright 2009-2018 LuxSoft - www.LuxSoft.eu

This file is part of the LuxCal Web Calendar.

The LuxCal Web Calendar is free software: you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software Foundation, 
either version 3 of the License, or (at your option) any later version.

The LuxCal Web Calendar is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the LuxCal 
Web Calendar. If not, see: http://www.gnu.org/licenses/.
*/

function showEvents(&$events,$date) {
	global $set, $usr, $hoverBox, $eDetails, $xx, $upcoTxt;
	
	$lastDate = '';
	foreach ($events as $evt) {
		$evtDate = makeD($date,5);
		$evtTime = $evt['ald'] ? $xx['vws_all_day'] : ITtoDT($evt['sti']).($evt['eti'] ? ' - '.ITtoDT($evt['eti']) : '');
		if ($set['eventColor']) {
			$eStyle = ($evt['cco'] ? 'color:'.$evt['cco'].';' : '').($evt['cbg'] ? 'background-color:'.$evt['cbg'].';' : '');
		} else {
			$eStyle = $evt['uco'] ? 'background-color:'.$evt['uco'].';' : '';
		}
		$eStyle = $eStyle ? ' style="'.$eStyle.'"' : '';
		$chBox = '';
		if ($evt['cbx']) {
			$mayCheck = ($usr['privs'] > 3 or ($usr['privs'] > 1 and $evt['uid'] == $usr['ID'])); //boolean
			$chBox .= !$evt['mde'] ? (strpos($evt['chd'], $date) ? $evt['cmk'] : '&#x2610;') : '?';
			$cBoxAtt = ($mayCheck and !$evt['mde']) ? "class='chkBox point' onclick=\"checkE(this,{$evt['eid']},'{$date}');\"" : 'class="chkBox"';
			$chBox = "<span title='{$evt['clb']}' {$cBoxAtt}>{$chBox}</span>";
		}
		if ($hoverBox) {
			$popText = "<b>{$evtTime}:".((!$evt['mde'] and $evt['eti']) ? ' - '.ITtoDT($evt['eti']) : '')." {$evt['tix']}</b><br>";
			if ($eDetails or $evt['mayE']) {
				$popText .= makeE($evt,$set['evtTemplPop'],'br','<br>');
			}
			$popText = htmlspecialchars(addslashes($popText));
			$popClass = ($evt['pri'] ? 'private' : 'normal').(($evt['mde'] or $evt['r_t']) ? ' repeat' : '');
			$popAttr = " onmouseover=\"pop(this,'{$popText}','{$popClass}')\"";
		} else {
			$popAttr = '';
		}
		$eBoxStyle = ($evt['app'] and !$evt['apd']) ? " style='border-left:2px solid #ff0000;'" : '';
		echo $lastDate != $evtDate ? "<br>\n<h5>{$evtDate}</h5>\n" : "<br>\n";
		echo "<table>\n<tr>\n<td class='widthCol1'>{$evtTime}</td>\n<td class='eBox'{$eBoxStyle}>";
		if ($eDetails or $evt['mayE']) {
			$click = ($evt['mayE'] ? 'editE' : 'showE')."({$evt['eid']},'{$date}')";
			echo "<span class='evtTitle bold'>{$chBox}<span class='point'{$eStyle} onclick=\"{$click};\"{$popAttr}>{$evt['tix']}</span></span>\n";
			echo makeE($evt,$set['evtTemplUpc'],'br',"<br>")."\n";
		} else {
			echo "<span class='evtTitle bold'>{$chBox}<span{$eStyle}{$popAttr}>{$evt['tix']}</span></span>\n";
		}
		echo "</td></tr></table>\n";
		//add text version to $upcoTxt
		if ($lastDate != $evtDate) { $upcoTxt .= "\n{$evtDate}\n".str_repeat('-',strlen($evtDate)); } //new or same date
		$upcoTxt .= "\n{$evtTime}\n".html_entity_decode($evt['tix'],ENT_QUOTES)."\n";
		if ($eDetails or $evt['mayE']) {
			$upcoTxt .= str_replace("<br>","\n",html_entity_decode(makeE($evt,$set['evtTemplUpc'],'br',"\n"),ENT_QUOTES))."\n";
		}
		$lastDate = $evtDate;
	}
}

//sanity check
if (empty($lcV)) { exit('not permitted ('.substr(basename(__FILE__),0,-4).')'); } //launch via script only

//initialize
$evtList = array();
$hoverBox = false;
if ($popFieldsArr = str_split($set['evtTemplPop'])) {
	foreach ($popFieldsArr as $fieldNr) {
		if (strpos($set['evtTemplUpc'],$fieldNr) === false) { $hoverBox = true; break; } // display hover box
	}
}
$eTime = mktime(12,0,0,substr($opt['cD'],5,2),substr($opt['cD'],8,2),substr($opt['cD'],0,4)) + (($set['lookaheadDays']-1) * 86400); //Unix time of end date
$eDate = date("Y-m-d", $eTime);
$fName = 'upco.txt';
$rName = str_replace('.','-'.date("Ymd-Hi").'.',$fName);

//display header
$tSpan = makeD($opt['cD'],2)." - ".makeD($eDate,2);
echo "<div class='subHead'>
	<button class='noPrint floatR' type='button' title='{$xx['vws_download_title']}' onclick=\"location.href='dloader.php?ftd={$fName}&amp;rName={$rName}'\">{$xx['vws_download']}</button>
	<h5 class='subHead bold'>{$tSpan}</h5>
	</div>\n";

//header download text file
$upcoTxt = "\n{$set['calendarTitle']}\n".str_repeat('=',strlen($set['calendarTitle']))."\n";
$upcoTxt .= "\n{$xx['title_upcoming']}  {$tSpan}\n".str_repeat('=',strlen($xx['title_upcoming']."  ".$tSpan))."\n";

//retrieve events
retrieve($opt['cD'],$eDate,'guc');

//display upcoming events
echo "<div class='eventBox".($isMob ? "'" : " scrollBoxUp' id='sBox'").">\n";
if ($evtList) {
	foreach($evtList as $date => &$events) {
		showEvents($events,$date);
	}
} else {
	echo $xx['none']."\n";
}
echo "</div>\n";
file_put_contents("./files/{$fName}",$upcoTxt,LOCK_EX); //save upco text file
?>
