<?php
/*
= week view of events =

 Copyright 2009-2018 LuxSoft - www.LuxSoft.eu

This file is part of the LuxCal Web Calendar.

The LuxCal Web Calendar is free software: you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software Foundation, 
either version 3 of the License, or (at your option) any later version.

The LuxCal Web Calendar is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the LuxCal 
Web Calendar. If not, see: http://www.gnu.org/licenses/.
*/

//sanity check
if (empty($lcV)) { exit('not permitted ('.substr(basename(__FILE__),0,-4).')'); } //launch via script only

//initialize
require './views/dw_functions.php';
$evtList = array();

$d = substr($opt['cD'],8,2);
$m = substr($opt['cD'],5,2);
$y = substr($opt['cD'],0,4);
$days = ($mode == 'fw') ? '0123456' : $set['workWeekDays']; //days to show
$sOffset = (date("w", mktime(12,0,0,$m,$d,$y)) - $set['weekStart'] + 7) % 7;
$sDow = $d-$sOffset; //first day of week
$sDayOfWk = date("Y-m-d", mktime(12,0,0,$m,$sDow,$y));
$eDayOfWk = date("Y-m-d", mktime(12,0,0,$m,$sDow+strlen($days)-1,$y));
$sDoLastW = date("Y-m-d", mktime(12,0,0,$m,$sDow-7,$y));
$sDoNextW = date("Y-m-d", mktime(12,0,0,$m,$sDow+7,$y));

/* display header */
$weekNr = $set['weekNumber'] ? ' ('.$xx['vws_week'].' '.date('W', mktime(12,0,0,$m,$sDow+1,$y)).')' : '';
$header = '&nbsp;<span'.($isMob ? '' : " class='viewHdr'").'>'.makeD($sDayOfWk,2).' - '.makeD($eDayOfWk,2)."{$weekNr}</span>&nbsp;";
$arrowL = "<a class='noPrint arrowLink' href=\"javascript:index({cD:'{$sDoLastW}'})\">&#9664;</a>";
$arrowR = "<a class='noPrint arrowLink' href=\"javascript:index({cD:'{$sDoNextW}'})\">&#9654;</a>";
$dateHdr = !$cH ? $header : "<a href=\"javascript:index({cP:'up'});\">{$header}</a>";
echo "<h5 class='floatC'>{$arrowL}{$dateHdr}{$arrowR}</h5>\n";

$cWidth = round(98 / strlen($days),1).'%';

/* display day headers */
echo "<div".($isMob ? '' : " class='scrollBoxHead'").">\n";
echo "<table class='grid'>
	<tr><th class='tCol'>{$xx['vws_time']}</th>\n";
for ($i=0;$i<7;$i++) {
	$cTime = mktime(12,0,0,$m,$sDow+$i,$y); //current time
	if (strpos($days,date("w",$cTime)) !== false) {
		$sDate = date("Y-m-d",$cTime);
		if (!$cH) {
			echo "<th class='dCol' style='width:{$cWidth}'>".makeD($sDate,($isMob ? 1 : 4),'xs')."</th>\n";
		} else {
			echo "<th class='dCol point' style='width:{$cWidth}' onclick=\"index({cP:6,cD:'{$sDate}'});\" title=\"{$xx['vws_view_day']}\">".makeD($sDate,($isMob ? 1 : 4),'xs')."</th>\n";
		}
	}
}
echo "</tr>\n</table>
	</div>";

/* retrieve events */
retrieve($sDayOfWk,$sDoNextW,'guc');

/* display days */
echo "<div".($isMob ? '' : " class='scrollBoxWe' id='sBox'").">\n";
echo "<table class='grid'>
	<tr><td class='tCol tColBg'>\n";
showHours();
echo "</td>\n";
for ($i=0;$i<7;$i++) {
	$cTime = mktime(12,0,0,$m,$sDow+$i,$y); //current time
	$cDate = date("Y-m-d", $cTime); //current date
	$dayNr = date("w",$cTime);
	if (strpos($days,$dayNr) !== false) {
		$dayBg = '';
		$curSeq = 0;
		if (!empty($evtList[$cDate])) { //check day background should be set
			foreach ($evtList[$cDate] as $evt) {
				if (($evt['dbg'] & 2) and $evt['seq'] > $curSeq) {
					$dayBg = " background:{$evt['cbg']};";
					$curSeq = $evt['seq'];
				}
			}
		}
		$dow = "<td class='dCol ".(strpos($set['workWeekDays'],$dayNr) === false ? 'we0' : 'wd0'); //week end or week day
		if ($cDate == date("Y-m-d")) {
			$dow .= ' today';
		} elseif ($cDate == $nD) {
			$dow .= ' slday';
		}
		$dow .= "'";
		echo $dow." style='width:$cWidth;{$dayBg}'>\n";
		showDay(date("Y-m-d",$cTime));
		echo "</td>\n";
	}
}
echo "</tr>\n</table>\n</div>\n";
?>